﻿Public Class frmScriptImport

    Private Sub btnClose_Click(sender As System.Object, e As System.EventArgs) Handles btnClose.Click
        Me.Close()
    End Sub

    Private Sub frmScriptImport_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Me.tmrStart.Start()
    End Sub

    Private Sub tmrStart_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrStart.Tick

        Me.tmrStart.Stop()
        '' Select same File as selected in Main Form
        Me.cboFiles.SelectedIndex = theMainForm.cboFiles.SelectedIndex
        '' Put HS3 Directory to text box
        Me.txtScriptFolder.Text = My.Settings.ExportDirectory
        
    End Sub
    Private Sub ScriptsToList()
        Dim DI As IO.DirectoryInfo, FIs() As IO.FileInfo, FI As IO.FileInfo
        Dim s As String
        Dim p As String
        '' Put HS3 Script Names to list
        clbScripts.Items.Clear()
        p = My.Settings.ExportDirectory
        If p.Substring(p.Length - 1) <> "\" Then p = p & "\"
        Try
            DI = New IO.DirectoryInfo(p)
            FIs = DI.GetFiles
            For Each FI In FIs
                If FI.Extension.ToUpper = ".VB" Then
                    s = FI.Name.Substring(0, FI.Name.Length - 3)
                    If Exports.ContainsKey(s) Then
                        '' Script already imported
                        s = "*" & s & " (Already Exists in tenScripting Project)"
                        If chkShowAll.Checked Then clbScripts.Items.Add(s)
                    Else
                        '' Script not imported yet
                        clbScripts.Items.Add(s)
                    End If
                End If
            Next
        Catch ex As Exception
            Beep()
            theMainForm.MyLog("Exception Importing Scripts from: " & p)
            theMainForm.MyLog(".... " & ex.Message)
            MsgBox("Error Ocurred, see tenScripting log", , "tenScripting3")
            Me.Close()
        End Try
    End Sub

    Private Sub btnImportScripts_Click(sender As System.Object, e As System.EventArgs) Handles btnImportScripts.Click
        ''
        '' Import the selected Scripts from HS3
        ''
        Dim SomeChecked As Boolean = False
        Dim sr As System.IO.StreamReader, sw As System.IO.StreamWriter
        Dim s, ed, p As String, scr As String, ii As Integer
        Dim Processed As String = ""

        '' Loop through all selected Scripts
        For i As Integer = 0 To Me.clbScripts.Items.Count - 1
            If Me.clbScripts.GetItemChecked(i) Then
                '' Checked Script found
                SomeChecked = True
                '' Read this Script file
                s = My.Settings.ExportDirectory
                If s.Substring(s.Length - 1) <> "\" Then s = s & "\"
                s = s & Me.clbScripts.Items(i).ToString & ".vb"
                sr = New System.IO.StreamReader(s)
                scr = sr.ReadToEnd()
                sr.Close()
                '' Append it to tenScripting Project File
                ed = My.Application.Info.DirectoryPath          'executable directory
                ii = ed.IndexOf("bin")                           'offset to project sub directory
                p = ed.Substring(0, ii)                          'path to project sub directory
                p = p & cboFiles.Items(cboFiles.SelectedIndex).ToString
                sw = New System.IO.StreamWriter(p, True)            'append
                sw.WriteLine(vbCrLf & "CLASS " & Me.clbScripts.Items(i).ToString)
                sw.Write(scr)
                sw.WriteLine(vbCrLf & "END CLASS")
                sw.Close()
                Processed = Processed & Me.clbScripts.Items(i).ToString.ToUpper & vbCrLf
            End If
        Next i
        If SomeChecked Then
            '' Processed Scripts
            MsgBox("The Following Scripts were Imported:" & vbCrLf & vbCrLf & Processed & vbCrLf & vbCrLf & "The tenScripting project will now terminate so you can edit your imported scripts", , "tenScripting3")
            End
        Else
            '' None Specified
            MsgBox("No Scripts Checked", , "tenScripting3")
        End If
    End Sub

    Private Sub clbScripts_ItemCheck(sender As System.Object, e As System.Windows.Forms.ItemCheckEventArgs) Handles clbScripts.ItemCheck
        Dim s As String
        s = clbScripts.Items(e.Index).ToString
        If e.NewValue = CheckState.Checked And s.Substring(0, 1) = "*" Then
            ''  The Script is already contained in the tenScripting Project
            MsgBox("Selected Script already defined in the tenScripting Project. Cannot Import it.", , "tenScripting3")
            e.NewValue = CheckState.Unchecked
        End If
    End Sub

    Private Sub chkShowAll_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles chkShowAll.CheckedChanged
        ''
        '' Refresh Display of Scripts
        ''
        ScriptsToList()
    End Sub

    Private Sub btnScriptFolder_Click(sender As System.Object, e As System.EventArgs) Handles btnScriptFolder.Click
        Dim frmSF As frmScriptFolder
        frmSF = New frmScriptFolder
        frmSF.ShowDialog()
        frmSF = Nothing
        '' Put HS3 Directory to text box
        Me.txtScriptFolder.Text = My.Settings.ExportDirectory
    End Sub

    Private Sub btnRetrieveScriptList_Click(sender As System.Object, e As System.EventArgs) Handles btnRetrieveScriptList.Click
        '' Put HS3 Script Names to list
        ScriptsToList()
    End Sub
End Class